struct hrtimer
Prev | High-resolution timers | Next

## Name

struct hrtimer — the basic hrtimer structure

## Synopsis

    struct hrtimer {
      struct rb_node node;
      ktime_t expires;
      enum hrtimer_restart		(* function) (struct hrtimer *);
      struct hrtimer_clock_base * base;
      unsigned long state;
      enum hrtimer_cb_mode cb_mode;
      struct list_head cb_entry;
    #ifdef CONFIG_TIMER_STATS
      void * start_site;
      char start_comm[16];
      int start_pid;
    #endif
    };

## Members

node

  red black tree node for time ordered insertion

expires

  the absolute expiry time in the hrtimers internal representation. The time is related to the clock on which the timer is based.

function

  timer expiry callback function

base

  pointer to the timer base (per cpu and per clock)

state

  state information (See bit values above)

cb_mode

  high resolution timer feature to select the callback execution mode

cb_entry

  list head to enqueue an expired timer into the callback list

start_site

  timer statistics field to store the site where the timer was started

start_comm[16]

  timer statistics field to store the name of the process which started the timer

start_pid

  timer statistics field to store the pid of the task which started the timer

## Description

The hrtimer structure must be initialized by `hrtimer_init`

Prev | Up | Next
ktime_equal | Home | struct hrtimer_sleeper